#ifndef _BASE_COLOR4_HPP_
#define _BASE_COLOR4_HPP_

// ------------------------------------------------------------------------------------------------
#include "SqBase.hpp"

// ------------------------------------------------------------------------------------------------
namespace SqMod {

/* ------------------------------------------------------------------------------------------------
 *
*/
struct Color4
{
    /* --------------------------------------------------------------------------------------------
     * ...
    */
    typedef unsigned char Value;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    static const Color4 NIL;
    static const Color4 MIN;
    static const Color4 MAX;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    static SQChar Delim;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Value r, g, b, a;

    /* --------------------------------------------------------------------------------------------
     *
    */
    Color4();

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4(Value sv);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4(Value rv, Value gv, Value bv);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4(Value rv, Value gv, Value bv, Value av);

    /* --------------------------------------------------------------------------------------------
     *
    */
    Color4(const Color4 & o);

    /* --------------------------------------------------------------------------------------------
     *
    */
    ~Color4();

    /* --------------------------------------------------------------------------------------------
     *
    */
    Color4 & operator = (const Color4 & o);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator = (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator = (CSStr name);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator = (const Color3 & c);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator += (const Color4 & c);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator -= (const Color4 & c);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator *= (const Color4 & c);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator /= (const Color4 & c);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator %= (const Color4 & c);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator &= (const Color4 & c);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator |= (const Color4 & c);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator ^= (const Color4 & c);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator <<= (const Color4 & c);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator >>= (const Color4 & c);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator += (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator -= (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator *= (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator /= (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator %= (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator &= (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator |= (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator ^= (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator <<= (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator >>= (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator ++ ();

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 & operator -- ();

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator ++ (int);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator -- (int);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator + (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator - (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator * (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator / (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator % (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator & (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator | (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator ^ (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator << (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator >> (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator + (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator - (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator * (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator / (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator % (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator & (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator | (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator ^ (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator << (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator >> (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator + () const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator - () const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Color4 operator ~ () const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator == (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator != (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator < (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator > (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator <= (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator >= (const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    operator Color3 () const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Int32 Cmp(const Color4 & c) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CSStr ToString() const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Set(Value ns);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Set(Value nr, Value ng, Value nb);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Set(Value nr, Value ng, Value nb, Value na);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Set(const Color4 & c);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Set(const Color3 & c);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Set(CSStr name, SQChar delim);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void SetCol(CSStr name);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Uint32 GetRGB() const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void SetRGB(Uint32 p);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Uint32 GetRGBA() const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void SetRGBA(Uint32 p);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Uint32 GetARGB() const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void SetARGB(Uint32 p);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Generate();

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Generate(Value min, Value max);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Generate(Value rmin, Value rmax, Value gmin, Value gmax, Value bmin, Value bmax, Value amin, Value amax);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Clear()
    {
        r = 0, g = 0, b = 0, a = 0;
    }

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Random();

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Inverse();
};

} // Namespace:: SqMod

#endif // _BASE_COLOR4_HPP_
