#ifndef _BASE_VECTOR2_HPP_
#define _BASE_VECTOR2_HPP_

// ------------------------------------------------------------------------------------------------
#include "SqBase.hpp"

// ------------------------------------------------------------------------------------------------
namespace SqMod {

/* ------------------------------------------------------------------------------------------------
 * 
*/
struct Vector2
{
    /* --------------------------------------------------------------------------------------------
     * ...
    */
    typedef float Value;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    static const Vector2 NIL;
    static const Vector2 MIN;
    static const Vector2 MAX;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    static SQChar Delim;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Value x, y;

    /* --------------------------------------------------------------------------------------------
     * 
    */
    Vector2();

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2(Value sv);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2(Value xv, Value yv);

    /* --------------------------------------------------------------------------------------------
     * 
    */
    Vector2(const Vector2 & o);

    /* --------------------------------------------------------------------------------------------
     * 
    */
    ~Vector2();

    /* --------------------------------------------------------------------------------------------
     * 
    */
    Vector2 & operator = (const Vector2 & o);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator = (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator = (CSStr values);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator = (const Vector2i & v);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator += (const Vector2 & v);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator -= (const Vector2 & v);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator *= (const Vector2 & v);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator /= (const Vector2 & v);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator %= (const Vector2 & v);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator += (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator -= (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator *= (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator /= (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator %= (Value s);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator ++ ();

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 & operator -- ();

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator ++ (int);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator -- (int);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator + (const Vector2 & v) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator - (const Vector2 & v) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator * (const Vector2 & v) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator / (const Vector2 & v) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator % (const Vector2 & v) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator + (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator - (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator * (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator / (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator % (Value s) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator + () const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 operator - () const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator == (const Vector2 & v) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator != (const Vector2 & v) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator < (const Vector2 & v) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator > (const Vector2 & v) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator <= (const Vector2 & v) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator >= (const Vector2 & v) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Int32 Cmp(const Vector2 & v) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CSStr ToString() const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Set(Value ns);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Set(Value nx, Value ny);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Set(const Vector2 & v);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Set(const Vector2i & v);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Set(CSStr values, SQChar delim);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Generate();

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Generate(Value min, Value max);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Generate(Value xmin, Value xmax, Value ymin, Value ymax);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Clear()
    {
        x = 0.0, y = 0.0;
    }

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2 Abs() const;
};

} // Namespace:: SqMod

#endif // _BASE_VECTOR2_HPP_